#include "stdafx.h"

SERVICE_STATUS          MyServiceStatus; 
SERVICE_STATUS_HANDLE   MyServiceStatusHandle; 
 
VOID __stdcall  MyServiceStart (DWORD argc, LPTSTR *argv); 
VOID __stdcall MyServiceCtrlHandler (DWORD opcode); 
DWORD MyServiceInitialization (DWORD argc, LPTSTR *argv, DWORD *specificError); 
VOID SvcDebugOut(LPTSTR String, DWORD Status);

 
LPTSTR MyServiceName = _T("myService");
LPTSTR MyServiceDisplayName = _T("my service display name");
extern LPCTSTR MyServicePathName;
extern MyHttpServer myHttpServer;


/*
int test()
{
	char buffer[2024];
	SC_HANDLE scHandle = NULL;
	ENUM_SERVICE_STATUS_PROCESS* pEnumStatus;
	DWORD bytesNeeded = 0;
	DWORD entryReturned = 0;
	DWORD resumeHandle = 0;
	DWORD err;

	if ((scHandle = OpenSCManager(NULL, NULL, SC_MANAGER_ALL_ACCESS|GENERIC_READ)) == NULL)
	{
		printf("error of [%d]\n", GetLastError());
		return 1;
	}
	pEnumStatus = (LPENUM_SERVICE_STATUS_PROCESS)buffer;


	while (true)
	{
		if (!EnumServicesStatusEx(scHandle, SC_ENUM_PROCESS_INFO, SERVICE_WIN32, SERVICE_STATE_ALL, 
			pEnumStatus, 2024, &bytesNeeded, &entryReturned, &resumeHandle,	NULL))
		{
			err = GetLastError();
			if ( err !=  ERROR_MORE_DATA)
			{
				printf("unknown error %u\n", err);
				break;
			}
		}
		else
		{
			printf("entry returned %d\n", entryReturned);
			_tprintf(_T("servicename[%s]displayname[%s]\n"), pEnumStatus->lpServiceName,
				pEnumStatus->lpDisplayName);
		}
	}

	return 0;
}
*/



void main( ) 
{ 
    SERVICE_TABLE_ENTRY   DispatchTable[2];
	
	DispatchTable[0].lpServiceName = MyServiceName;
	DispatchTable[0].lpServiceProc = MyServiceStart;
	DispatchTable[1].lpServiceName = NULL;
	DispatchTable[1].lpServiceProc = NULL;

    
    if (!StartServiceCtrlDispatcher(DispatchTable)) 
    { 
        SvcDebugOut(_T(" [MY_SERVICE] StartServiceCtrlDispatcher error = %d\n"), GetLastError()); 
    } 
} 
 
VOID SvcDebugOut(LPTSTR String, DWORD Status) 
{ 
    TCHAR  Buffer[1024]; 
    if (_tcslen(String) < 1000) 
    { 
        _stprintf(Buffer, String, Status); 
        OutputDebugString(Buffer); 
    } 
} 

VOID __stdcall MyServiceCtrlHandler (DWORD Opcode) 
{ 
    DWORD status; 
 
    switch(Opcode) 
    { 
        case SERVICE_CONTROL_PAUSE: 
        // Do whatever it takes to pause here. 			
			//MyServiceStatus.dwCurrentState = SERVICE_PAUSED; 
			MyServiceStatus.dwCurrentState = myPauseService(); 
            break;  
        case SERVICE_CONTROL_CONTINUE: 
        // Do whatever it takes to continue here. 
            //MyServiceStatus.dwCurrentState = SERVICE_RUNNING; 
			MyServiceStatus.dwCurrentState = myContinueService(); 
            break; 
 
        case SERVICE_CONTROL_STOP: 
        // Do whatever it takes to stop here. 
            MyServiceStatus.dwWin32ExitCode = 0; 
            //MyServiceStatus.dwCurrentState  = SERVICE_STOPPED; 
			MyServiceStatus.dwCurrentState  = myStopService(); 
            MyServiceStatus.dwCheckPoint    = 0; 
            MyServiceStatus.dwWaitHint      = 100; 
			break;
 
        case SERVICE_CONTROL_INTERROGATE: 
        // Fall through to send current status. 
            break; 
 
        default: 
            SvcDebugOut(_T(" [MY_SERVICE] Unrecognized opcode %ld\n"), 
                Opcode); 
    } 
 
    // Send current status. 
    if (!SetServiceStatus (MyServiceStatusHandle,  &MyServiceStatus)) 
    { 
        status = GetLastError(); 
        SvcDebugOut(_T(" [MY_SERVICE] SetServiceStatus error %ld\n"),status); 
    } 
} 


void __stdcall MyServiceStart (DWORD argc, LPTSTR *argv) 
{ 
    DWORD status; 
    DWORD specificError; 
 
    MyServiceStatus.dwServiceType        = SERVICE_WIN32; 
    MyServiceStatus.dwCurrentState       = SERVICE_START_PENDING; 
    MyServiceStatus.dwControlsAccepted   = 0; //SERVICE_ACCEPT_STOP ; 
    MyServiceStatus.dwWin32ExitCode      = 0; 
    MyServiceStatus.dwServiceSpecificExitCode = 0; 
    MyServiceStatus.dwCheckPoint         = 0; 
    MyServiceStatus.dwWaitHint           = 0; 
 
    MyServiceStatusHandle = RegisterServiceCtrlHandler(MyServiceName, MyServiceCtrlHandler); 

	myHttpServer.myLog.logEvent(L"code safe starts.....\n");
    if (MyServiceStatusHandle == (SERVICE_STATUS_HANDLE)0) 
    { 
        SvcDebugOut(_T(" [MY_SERVICE] RegisterServiceCtrlHandler failed %d\n"), GetLastError()); 
        return; 
    } 
 
	//DebugBreak();
    // Initialization code goes here. 
    status = MyServiceInitialization(argc, argv, &specificError); 
 
    // Handle error condition 
    if (status != NO_ERROR) 
    { 
        MyServiceStatus.dwCurrentState       = SERVICE_STOPPED; 
        MyServiceStatus.dwCheckPoint         = 0; 
        MyServiceStatus.dwWaitHint           = 0; 
        MyServiceStatus.dwWin32ExitCode      = status; 
        MyServiceStatus.dwServiceSpecificExitCode = specificError; 
 
        SetServiceStatus (MyServiceStatusHandle, &MyServiceStatus); 
		myHttpServer.myLog.logEvent(L"code safe stop unexpectedly\n");
        return; 
    } 
 
    // Initialization complete - report running status. 
    MyServiceStatus.dwCurrentState       = SERVICE_RUNNING; 
    MyServiceStatus.dwCheckPoint         = 0; 
    MyServiceStatus.dwWaitHint           = 0; 
 
    if (!SetServiceStatus (MyServiceStatusHandle, &MyServiceStatus)) 
    { 
        status = GetLastError(); 
        SvcDebugOut(_T(" [MY_SERVICE] SetServiceStatus error %ld\n"),status); 
    } 
 
    // This is where the service does its work. 
    SvcDebugOut(_T(" [MY_SERVICE] Returning the Main Thread \n"),0); 
	myRunService();
	
    return; 
} 
 

